<template>
  <AppAbstractSearch
    :results-loader="resultsLoader"
    v-model="query"
    @search="search(); $ym('ppn_search_action')">
    <template
      v-if="$slots['additional-slot']"
      #additional-slot>
      <slot name="additional-slot"/>
    </template>
    <template #suggestion-item="{ suggestion }">
      <flink
        :href="getHrefByOptions(suggestion)"
        class="suggestion">
        <div class="suggestion-wrapper">
          <div class="suggestion-unit _brand">
            {{ suggestion.manufacturer.brand }}
          </div>
          <div class="suggestion-unit _number">
            {{ suggestion.vendor_code }}
          </div>
          <div class="suggestion-unit _name">
            {{ suggestion.name }}
          </div>
        </div>
      </flink>
    </template>
  </AppAbstractSearch>
</template>

<script>
import { get } from 'lodash-es';

import { specifyingSearchRequest } from '~/assets/js/filters';
import mapFilters from '~/assets/js/helpers/map-filters';

import AppAbstractSearch from '~/components/redesign/app-search/app-abstract-search';

export default {
  name: 'AppSearch',
  components: {
    AppAbstractSearch,
  },
  props: {
    current: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      query: this.current,
    };
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    getHrefByOptions(item) {
      const url = ['/poisk-po-nomeru'];
      url.push(this.brandSlug(get(item, 'manufacturer.brand', '')));
      url.push(this.vendorCodeSlug(item.vendor_code));
      return url.join('/');
    },
    resultsLoader(query) {
      return new Promise((resolve) => {
        this.$axios.$get('/_search/searchItem/find', { params: { query: specifyingSearchRequest(query) } })
          .then(({ data }) => {
            if (data.items) {
              resolve(data.items);
            }
            resolve([]);
          });
      });
    },
    search() {
      let query = this.query;
      query = query.replace(new RegExp(/[\\/ ]+/g), ' ').trim();
      query = encodeURIComponent(query);
      if (query) {
        this.$router.push({ path: `/search/${query}` });
      }
    },
  },
};
</script>

<style lang="postcss">
</style>
